﻿

-- Portrait icons for each specialization
SPEC_PORTRAITS_LIST = {	
	"Interface\\ICONS\\Ability_Druid_OwlkinFrenzy.blp",
	"Interface\\ICONS\\INV_Staff_99.blp",
	"Interface\\ICONS\\ABILITY_DRUID_DEMORALIZINGROAR.blp",
	"Interface\\ICONS\\Ability_Druid_NaturalPerfection.blp"
}

SPEC_PORTRAITS_LIST_UNFORM = {
	"Interface\\ICONS\\INV_MISC_PETMOONKINNE.blp",
	"Interface\\ICONS\\Achievement_Halloween_Cat_01.blp",
	"Interface\\ICONS\\inv_misc_bearcubbrown.blp",
	"Interface\\ICONS\\Ability_Druid_NaturalPerfection.blp"
}

--Primary buffs for each specialization
SPEC_BUFF_LIST = {16886, 127538, 62606, 100977}

-- AlertFrame 
AlertFrame = CreateFrame("Frame"); 
AlertFrame:ClearAllPoints(); 
AlertFrame:SetHeight(100); 
AlertFrame:SetWidth(100); 
AlertFrame:SetPoint("CENTER", UIParent, "CENTER");
AlertFrame:SetScript("OnUpdate", function(self, elapsed)
	if (AlertFrame.Time < GetTime() - 3) then		
		local alpha = AlertFrame:GetAlpha()
		if (alpha ~= 0) then AlertFrame:SetAlpha(alpha - .05) end
		if (aplha == 0) then AlertFrame:Hide() end
	end
end
) 
AlertFrame:Hide(); 
AlertFrame.text = AlertFrame:CreateFontString(nil, "BACKGROUND", "PVPInfoTextFont"); 
AlertFrame.text:SetAllPoints(); 
AlertFrame.Time = 0;
  
function AlertMsg(message, color) 
	AlertFrame.text:SetText(message); 
	if color=="green" then
		AlertFrame.text:SetTextColor(0,1,0)
	elseif color == "red" then
		AlertFrame.text:SetTextColor(1,0,0)
	else 
		AlertFrame.text:SetTextColor(1,1,1)
	end
	AlertFrame:SetAlpha(1); 
	AlertFrame:Show(); 
	AlertFrame.Time = GetTime(); 
end
----------------------------------------------------------------------------------------------



-- Setup power bars' heights
function MSS_PowerFrame_OnLoad(self)
	local height = 20
	self.RageBar:SetHeight(height)
	self.EnergyBar:SetHeight(height)
	self.ManaBar:SetHeight(height)
	self.EclipseBar:SetHeight(height)	
	
	self.EclipseBar.Lunar:SetHeight(height)
	self.EclipseBar.LunarMask:SetHeight(height)
	self.EclipseBar.Solar:SetHeight(height)
	self.EclipseBar.SolarMask:SetHeight(height)
end


function RageBar_OnUpdate(self, elapsed)
	if GetShapeshiftFormID() == 5 then
		local currentChance = self:GetValue()
		local newChance = UnitPower("player", SPELL_POWER_RAGE)	
		if newChance - currentChance > 1 then
			self:SetValue(currentChance + 1)
		elseif newChance - currentChance <= 1  and newChance - currentChance > 0 then
			self:SetValue(newChance)
		elseif currentChance - newChance > 10 then
			self:SetValue(currentChance - 10)
		elseif currentChance - newChance > 0 and currentChance - newChance < 10 then
			self:SetValue(newChance)
		end 
		self.text:SetText(self:GetValue())
		local _, maxValue = self:GetMinMaxValues()
		self.spark:SetPoint("LEFT", self, "LEFT", self:GetValue()/maxValue*176 - 15, -1)
	else 
		self:SetValue(0)
		self.text:SetText(self:GetValue())
		self.spark:SetPoint("LEFT", self, "LEFT", - 15, -3)
	end	
end


function EnergyBar_OnUpdate(self, elasped)
	local currentChance = self:GetValue()
	local newChance = UnitPower("player", SPELL_POWER_ENERGY)	
	if newChance - currentChance > 10 then
		self:SetValue(currentChance + 10)
	elseif newChance - currentChance <= 10  and newChance - currentChance > 0 then
		self:SetValue(newChance)
	elseif currentChance - newChance > 10 then
		self:SetValue(currentChance - 10)
	elseif currentChance - newChance > 0 and currentChance - newChance < 10 then
		self:SetValue(newChance)
	end 
	self.text:SetText(self:GetValue())
	local _, maxValue = self:GetMinMaxValues()
	self.spark:SetPoint("LEFT", self, "LEFT", self:GetValue()/maxValue*176 - 15, -1)
end


function ManaBar_OnLoad(self) 		
		--?
end


function ManaBar_OnUpdate(self, elasped)
	--self:SetMinMaxValues(0, UnitPower("player", SPELL_POWER_MANA)) 
	local currentChance = self:GetValue()
	local newChance = UnitPower("player", SPELL_POWER_MANA)		
	self:SetValue(newChance)	
	local _, maxValue = self:GetMinMaxValues()
	self.spark:SetPoint("LEFT", self, "LEFT", newChance/maxValue*176 - 15, -3)
	self.text:SetText(newChance)
end


function EclipseBar_OnUpdate(self, elapsed)
	MasterSS_SolarMask:SetFrameLevel(100)
	MasterSS_LunarMask:SetFrameLevel(100)
	
	local newChance = UnitPower("player", SPELL_POWER_ECLIPSE)	
	local direction = GetEclipseDirection()	
	
	if newChance >= 0 then
		MasterSS_SolarMask:SetValue(newChance)
		MasterSS_LunarMask:SetValue(0)
	elseif newChance < 0 then
		MasterSS_LunarMask:SetValue(newChance)
		MasterSS_SolarMask:SetValue(0)
	end
	
	-- Set spark
	MasterSS_LunarMask.spark:SetPoint("LEFT", MasterSS_LunarMask, "LEFT", (100 + MasterSS_LunarMask:GetValue())/100*88 - 15, -3)
	MasterSS_SolarMask.spark:SetPoint("LEFT", MasterSS_SolarMask, "LEFT", MasterSS_SolarMask:GetValue()/100*88 - 15, -3)	
	
	if (newChance > 0 and direction == "moon") or self.nextToEclipse == 1 then -- Sun Eclipse
		SolarIconActive:Show()		
		SolarIconActive.pulse:Play()
	else 
		SolarIconActive:Hide()
	end
	
	if (newChance < 0 and direction == "sun") or self.nextToEclipse == -1 then -- Moon Eclipse
		LunarIconActive:Show()		
		LunarIconActive.pulse:Play()
	else 
		LunarIconActive:Hide()
	end
	
	if newChance < 0 then
		newChance = -newChance
	end
	if direction == "moon" then
		MasterSS_EclipseBar_Text:SetPoint("CENTER", self, "CENTER", -30,1)
		MasterSS_EclipseBar_Text:SetText("<"..newChance)
	elseif direction == "sun" then
		MasterSS_EclipseBar_Text:SetPoint("CENTER", self, "CENTER", 30,1)
		MasterSS_EclipseBar_Text:SetText(newChance..">")
	else
		MasterSS_EclipseBar_Text:SetPoint("CENTER", self, "CENTER", 0, 1)
		MasterSS_EclipseBar_Text:SetText("<"..newChance..">")
	end	
end


function EclipseBar_OnEvent(self, event, ...)
	local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = select(1, ...)
	
	if sourceName == UnitName("player") then
	
			if eventType == "SPELL_CAST_START" then
				local spellId, spellName, spellSchool = select(12, ...)
				local auraType = select(15, ...)
				--MasterSS:showMsg(spellId .."-".. spellName)
				local power = UnitPower("player", SPELL_POWER_ECLIPSE)
				
				if spellId == 2912  then -- starfire
					if power >= 60 and GetEclipseDirection() == "sun" then
						MasterSS_EclipseBar_Text:SetTextColor(0,1,0)
						SolarIconActive:Show()
						self.nextToEclipse = 1
						AlertMsg("即将进蚀", "green")
					end
					
					if power >= -40 and power < -20 and GetEclipseDirection() == "sun" then
						MasterSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀", "red")
					end												
				end
				
				if spellId == 5176 then --wrath
					if power <= -70 and GetEclipseDirection() == "moon" then
						MasterSS_EclipseBar_Text:SetTextColor(0,1,0)
						LunarIconActive:Show()
						self.nextToEclipse = -1
						AlertMsg("即将进蚀","green")
					end
					
					if power <= 35 and power > 15 and GetEclipseDirection() == "moon" then
						MasterSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀", "red")
					end												
				end
				
				if spellId == 78674 then -- starsurge
					if power >= 60 and GetEclipseDirection() == "sun" then
						MasterSS_EclipseBar_Text:SetTextColor(0,1,0)						
						self.nextToEclipse = 1
						AlertMsg("即将进蚀","green")
					end
					if power <= -60 and GetEclipseDirection() == "moon" then
						MasterSS_EclipseBar_Text:SetTextColor(0,1,0)						
						
						self.nextToEclipse = -1
						AlertMsg("即将进蚀","green")
					end	
					if power >= -40 and power < -20 and GetEclipseDirection() == "sun" then
						MasterSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀","red")
					end
					if power <= 35 and power > 20 and GetEclipseDirection() == "moon" then
						MasterSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀", "red")
					end	
				end--starsurge				
			end--cast start
			
			if eventType == "SPELL_ENERGIZE" or eventType == "SPELL_CAST_FAILED" then
				MasterSS_EclipseBar_Text:SetTextColor(1,1,1)
				if self.nextToEclipse == -1 then
					self.nextToEclipse = 0
					LunarIconActive:Hide()
				elseif self.nextToEclipse == 1 then
					self.nextToEclipse = 0
					SolarIconActive:Hide()
				end
			end
	end	
end


-- Setup a combo orb
local function SetCombo(specId, combo, active, inCD)
	if active then
		if specId == 1 or specId == 4 then
			if inCD then
				combo:SetTexture("Interface/COMMON/Indicator-Yellow.blp")
			else
				combo:SetTexture("Interface/COMMON/Indicator-Green.blp")
			end
		elseif specId == 2 then
			combo:SetTexture("Interface/COMMON/Indicator-Yellow.blp")
		elseif specId == 3 then
			if inCD then
				combo:SetTexture("Interface/COMMON/Indicator-Yellow.blp")
			else 	
				combo:SetTexture("Interface/COMMON/Indicator-Red.blp")
			end
		end
	else 
		combo:SetTexture("Interface/COMMON/Indicator-Gray.blp")
	end
end


function ComboBar_OnUpdate(self, elapsed)
	local spec = GetSpecialization()
	MasterSS_ComboTimer:Hide()
	if  spec == 2 or GetShapeshiftFormID() == 1 then -- Feral spec or Cat form
		local pts = GetComboPoints("player", "target")
		local spec = 2
		if pts == 0 then
			SetCombo(spec, MasterSS_Combo1, false)
			SetCombo(spec, MasterSS_Combo2, false)
			SetCombo(spec, MasterSS_Combo3, false)
			SetCombo(spec, MasterSS_Combo4, false)
			SetCombo(spec, MasterSS_Combo5, false)			
		elseif pts == 1 then
			SetCombo(spec, MasterSS_Combo1, true)
			SetCombo(spec, MasterSS_Combo2, false)
			SetCombo(spec, MasterSS_Combo3, false)
			SetCombo(spec, MasterSS_Combo4, false)
			SetCombo(spec, MasterSS_Combo5, false)		
		elseif pts == 2 then
			SetCombo(spec, MasterSS_Combo1, true)
			SetCombo(spec, MasterSS_Combo2, true)
			SetCombo(spec, MasterSS_Combo3, false)
			SetCombo(spec, MasterSS_Combo4, false)
			SetCombo(spec, MasterSS_Combo5, false)		
		elseif pts == 3 then
			SetCombo(spec, MasterSS_Combo1, true)
			SetCombo(spec, MasterSS_Combo2, true)
			SetCombo(spec, MasterSS_Combo3, true)
			SetCombo(spec, MasterSS_Combo4, false)
			SetCombo(spec, MasterSS_Combo5, false)		
		elseif pts == 4 then
			SetCombo(spec, MasterSS_Combo1, true)
			SetCombo(spec, MasterSS_Combo2, true)
			SetCombo(spec, MasterSS_Combo3, true)
			SetCombo(spec, MasterSS_Combo4, true)
			SetCombo(spec, MasterSS_Combo5, false)
		elseif pts == 5 then
			SetCombo(spec, MasterSS_Combo1, true)
			SetCombo(spec, MasterSS_Combo2, true)
			SetCombo(spec, MasterSS_Combo3, true)
			SetCombo(spec, MasterSS_Combo4, true)
			SetCombo(spec, MasterSS_Combo5, true)
		end
	elseif spec == 3 then -- Bear
		local pts, maxCharges, timeLastCast, cooldownDuration  = GetSpellCharges(62606)
		local left = cooldownDuration - GetTime() + timeLastCast
		MasterSS_ComboTimer:SetText(string.format("%d", left))
		MasterSS_ComboTimer:Show()
		local _, _, _, powerCost = GetSpellInfo(62606) 
		local low = UnitPower("player", SPELL_POWER_RAGE) < powerCost
		if pts == 0 then		
			MasterSS_ComboTimer:SetPoint("CENTER", MasterSS_Combo3, "CENTER",1,2)
			SetCombo(spec, MasterSS_Combo3, false, low)
			SetCombo(spec, MasterSS_Combo4, false, low)
			SetCombo(spec, MasterSS_Combo5, false, low)			
		elseif pts == 1 then			
			MasterSS_ComboTimer:SetPoint("CENTER", MasterSS_Combo4, "CENTER",1,2)
			SetCombo(spec, MasterSS_Combo3, true, low)
			SetCombo(spec, MasterSS_Combo4, false, low)
			SetCombo(spec, MasterSS_Combo5, false, low)		
		elseif pts == 2 then			
			MasterSS_ComboTimer:SetPoint("CENTER", MasterSS_Combo5, "CENTER",1,2)
			SetCombo(spec, MasterSS_Combo3, true, low)
			SetCombo(spec, MasterSS_Combo4, true, low)
			SetCombo(spec, MasterSS_Combo5, false, low)		
		elseif pts == 3 then			
			MasterSS_ComboTimer:Hide()
			SetCombo(spec, MasterSS_Combo3, true, low)
			SetCombo(spec, MasterSS_Combo4, true, low)
			SetCombo(spec, MasterSS_Combo5, true, low)	
		end	
	elseif spec == 1 or spec == 4 then -- moonkin mushroom
		local pts = 0
		local i
		for i = 1,3 do
			local haveTotem, _, _, _, _ = GetTotemInfo(i)
			if haveTotem then 
				pts = pts + 1
			end
		end
		local start1, _,_ = GetSpellCooldown(88751)
		local start2, _,_ = GetSpellCooldown(102791)
		local inCD = start1 ~= 0 or start2 ~= 0
		if pts == 0 then			
			SetCombo(spec, MasterSS_Combo3, false, inCD)
			SetCombo(spec, MasterSS_Combo4, false, inCD)
			SetCombo(spec, MasterSS_Combo5, false)			
		elseif pts == 1 then			
			SetCombo(spec, MasterSS_Combo3, true, inCD)
			SetCombo(spec, MasterSS_Combo4, false, inCD)
			SetCombo(spec, MasterSS_Combo5, false, inCD)		
		elseif pts == 2 then			
			SetCombo(spec, MasterSS_Combo3, true, inCD)
			SetCombo(spec, MasterSS_Combo4, true, inCD)
			SetCombo(spec, MasterSS_Combo5, false, inCD)		
		elseif pts == 3 then			
			SetCombo(spec, MasterSS_Combo3, true,inCD)
			SetCombo(spec, MasterSS_Combo4, true,inCD)
			SetCombo(spec, MasterSS_Combo5, true,inCD)	
		end
	end
end


-- Set comboBar to match current spec or form
function ResetComboBar()
	local spec = GetSpecialization()
	if spec == 2 then
		MasterSS_ComboBorder1:Show()
		MasterSS_ComboBorder2:Show()
		MasterSS_Combo1:Show()
		MasterSS_Combo2:Show()
	else 
		local form = GetShapeshiftFormID()
		if form == 1 then
			MasterSS_ComboBorder1:Show()
			MasterSS_ComboBorder2:Show()
			MasterSS_Combo1:Show()
			MasterSS_Combo2:Show()
		else 
			MasterSS_ComboBorder1:Hide()
			MasterSS_ComboBorder2:Hide()
			MasterSS_Combo1:Hide()
			MasterSS_Combo2:Hide()
		end	
	end
end 


-- Primary buff bar
function BuffBar_OnUpdate(self, elapsed)
	self.total = self.total + elapsed
	
	if self.total >= .1 then		
		self.total = 0
		if MasterSS_BuffStatusBar:GetValue() > 0 then
			MasterSS_BuffStatusBar:SetValue(MasterSS_BuffStatusBar:GetValue() - 0.1)
			BuffBar_Text:SetText(string.format("%.1f", MasterSS_BuffStatusBar:GetValue()))
		else
			BuffBar_Text:SetText("")
		end
		if GetSpecialization() == 3 then
			BuffBar_Text2:SetText(string.format("%.1f",GetDodgeChance()).."%")
		end
	end	
end

function BuffBar_OnEvent(self, event, ...)
	local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = select(1, ...)
	if sourceName == UnitName("player") then
		--print(eventType)
		if eventType == "SPELL_CAST_SUCCESS" or eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_REFRESH" then
			local spellId, spellName, spellSchool = select(12, ...)
			local auraType = select(15, ...)
			print(eventType.."-"..spellId.."-"..spellName)
			if spellId == SPEC_BUFF_LIST[GetSpecialization()] then
				local name, rank, icon, count, dispelType, duration, expires = UnitBuff("player", spellName)
				MasterSS_BuffStatusBar:SetValue(duration)		
				MasterSS_BuffPortrait:SetTexture(icon)
			end			
		end
	end
end



-- Debuff
local DEBUFF_LIST = {
	{nil, nil, 93402,8921}, --Moonkin
	{106830, 113746, 1822, 1079}, --Cat
	{nil, 113746, 33745, 77758}, --Bear
	{nil, nil, nil, nil}
}

--Cast-when-ready Abilities
local BUFF1_LIST = {
	{78674, 48505, nil, nil}, --Moonkin
	{5217, nil, nil, nil}, --Cat
	{33878, nil, nil, nil}, --Bear
	{18562, 48438, nil, nil} -- resto
}

--Long-cd abilities
-- 124974 nature vigil
local BUFF2_LIST = {
	{112071, 102560, nil, nil}, --Moonkin
	{106952, 102543, nil, nil}, --Cat
	{106952, 102558, nil, nil}, --Bear
	{740,    117679, nil, nil} --resto
}

function MSS_AuraSlot_OnUpdate(self, elapsed)
	if self.spellId then
		local spellName = GetSpellInfo(self.spellId)		
		self.bg:SetTexture(select(3, GetSpellInfo(self.spellId)))
		
		if self.isDebuff then -- Debuff
			local name, rank, icon, count, dispelType, duration, expires, caster = UnitDebuff("target", spellName)
			if name ~= nil and (self.ignoreCaster or caster == "player") then -- active on target
				
				self.cooldown:SetReverse(true)
				self.cooldown:SetCooldown(expires - duration, duration)
				self.bg:SetAlpha(1.0)
              --	self.bg:SetTexture(icon)
				local leftTime = format("%d", expires - GetTime())
				if expires - GetTime() >= 3 then
					self.text:SetTextColor(0,1,0)
				else 
					self.text:SetTextColor(1,0,0)
				end
				self.text:SetText(leftTime)
				self.text:Show()
			else -- not on target
				self.bg:SetAlpha(0.5)
				self.text:Hide()
				self.cooldown:SetCooldown(0,0)
			end
		else -- Buff 	
			local name, rank, icon, count, dispelType, duration, expires = UnitAura("player", spellName)
			if name ~= nil then --active
				self.bg:SetAlpha(1.0)				
				local leftTime = format("%d", expires - GetTime())			
				self.text:SetTextColor(0,1,0)			
				self.text:SetText(leftTime)
				self.text:Show()
			else 
				local start, duration, enable = GetSpellCooldown(self.spellId)
				self.cooldown:SetCooldown(start, duration)
				if start ~= 0 and duration > 1.5 then --In CD					
					self.bg:SetAlpha(0.5)
					self.text:SetTextColor(1,0,0)
					local leftTime = duration - GetTime() + start
					local t
					self.text:SetFontObject("PVPInfoTextFont")
					if leftTime >= 60 then
						self.text:SetFontObject("NumberFont_Shadow_Small")
						t = format("%d", leftTime/60) .. ":" .. format("%02d", leftTime%60)
					elseif leftTime >= 1 then
						t = format("%d", leftTime)
					elseif leftTime >0 then
						t = format("%.1f", leftTime)	
					end
					self.text:Show()
					self.text:SetText(t)
					if self.glowWhenReady and self.glow.playing == 1 then
						self.glow:Hide()
						self.glow.animIn:Stop()
						self.glow.playing = 0
					end
				else -- CD ready
					self.bg:SetAlpha(1)
					self.text:Hide()
					if self.glowWhenReady and self.glow.playing == 0 then
						self.glow:Show()
						self.glow.animIn:Play()
						self.glow.playing = 1
					end
				end			
			end		
		end
	else
		self:Hide()
	end
end



--[[
local function SetAuraSlot(slot, spellId, hidden)
	if spellId ~= nil and not hidden then
		slot.bg:SetTexture(select(3, GetSpellInfo(spellId)))
		slot:Show()
		slot.cooldown:SetCooldown(0,0)
	else 
		slot:Hide()
	end
end
]]

-- Setup aura icons
-- Provoked when player change specialization or talent
function SetupAura(spec)
	if spec == 1 or spec == 2 or spec == 3 or spec == 4 then
		for i = 1, 4 do
			_G["MasterSS_BuffFrame1_Slot"..i].spellId = BUFF1_LIST[spec][i]			
			_G["MasterSS_BuffFrame1_Slot"..i].isDebuff = false 
			_G["MasterSS_BuffFrame1_Slot"..i].glowWhenReady = true	
			_G["MasterSS_BuffFrame1_Slot"..i]:SetAttribute("spell", BUFF1_LIST[spec][i])
			
			_G["MasterSS_BuffFrame2_Slot"..i].spellId = BUFF2_LIST[spec][i]
			_G["MasterSS_BuffFrame2_Slot"..i].isDebuff = false
			_G["MasterSS_BuffFrame2_Slot"..i].glowWhenReady = false		
			_G["MasterSS_BuffFrame2_Slot"..i]:SetAttribute("spell", BUFF2_LIST[spec][i])
			
			_G["MasterSS_DebuffFrame_Slot"..i].spellId = DEBUFF_LIST[spec][i]
			_G["MasterSS_DebuffFrame_Slot"..i].isDebuff = true
			_G["MasterSS_DebuffFrame_Slot"..i].glowWhenReady = false
			_G["MasterSS_DebuffFrame_Slot"..i]:SetAttribute("spell", DEBUFF_LIST[spec][i])
		end
		MasterSS_DebuffFrame_Slot1.ignoreCaster = true
		
		local isFree, index = GetTalentRowSelectionInfo(4)
		if isFree or index ~= 11 then
			MasterSS_BuffFrame2_Slot2.spellId = nil
		end
		
		isFree, index = GetTalentRowSelectionInfo(6)
		if index == 18 then
			if MasterSS_BuffFrame2_Slot2.spellId == nil then
				MasterSS_BuffFrame2_Slot2.spellId = 124974 --nature's vigil
				MasterSS_BuffFrame2_Slot2.isDebuff = false
				MasterSS_BuffFrame2_Slot2.glowWhenReady = false
			else 
				MasterSS_BuffFrame2_Slot3.spellId = 124974 --nature's vigil
				MasterSS_BuffFrame2_Slot3.isDebuff = false
				MasterSS_BuffFrame2_Slot3.glowWhenReady = false
			end			
		end
		
		for i = 1, 4 do
			if _G["MasterSS_BuffFrame1_Slot"..i].spellId ~= nil then
				_G["MasterSS_BuffFrame1_Slot"..i]:Show()
			end
			if _G["MasterSS_BuffFrame2_Slot"..i].spellId ~= nil then
				_G["MasterSS_BuffFrame2_Slot"..i]:Show()
			end
			if _G["MasterSS_DebuffFrame_Slot"..i].spellId ~= nil then
				_G["MasterSS_DebuffFrame_Slot"..i]:Show()
			end			
			
		end
		

	end
end




-- Update player portrait icon
function UpdatePortrait() 
	if UnitIsDeadOrGhost("player") == 1 then
		MasterSS_Portrait:SetTexture("Interface\\ICONS\\INV_MISC_FOOD_15.blp")
	elseif GetSpecialization() == nil then
		MasterSS_Portrait:SetTexture("Interface\\ICONS\\Ability_Druid_MasterShapeshifter.blp")
	else
		if GetShapeshiftFormID() == nil then
			MasterSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST_UNFORM[GetSpecialization()])
		else			
			if (GetSpecialization() == 1 and GetShapeshiftFormID() == 31) or (GetSpecialization() == 2 and GetShapeshiftFormID() == 1) or (GetSpecialization() == 3 and GetShapeshiftFormID() == 5) then
				MasterSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST[GetSpecialization()])
			else
				MasterSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST_UNFORM[GetSpecialization()])
			end
		end
	end
end 

-- Setup frame after changing specialization
function MSS_OnChangeSpecialization()
	local SPEC_ID = GetSpecialization()	
	
	MasterSS.powerFrame.RageBar:Hide()
	MasterSS.powerFrame.EnergyBar:Hide()
	MasterSS.powerFrame.ManaBar:Hide()
	MasterSS.powerFrame.EclipseBar:Hide()
	
	ResetComboBar()
	MasterSS_ComboFrame:Show()

	SetupAura(SPEC_ID)	
	
	MasterSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST_UNFORM[SPEC_ID])
	ManaBar_OnLoad(MasterSS.powerFrame.ManaBar)
	
	if SPEC_ID == 1 then --Monnkin
		MasterSS.powerFrame.EclipseBar:Show()
		MasterSS_BuffStatusBar:SetMinMaxValues(0,18)
		MasterSS_BuffStatusBar:SetValue(0)
	    MasterSS_BuffStatusBar:SetStatusBarColor(0.13,0.93,0)
		MasterSS_BuffStatusBar.text:Hide()
		
	elseif SPEC_ID == 2 then --Cat
		MasterSS.powerFrame.EnergyBar:Show()	
		MasterSS_BuffStatusBar:SetMinMaxValues(0,45)
		MasterSS_BuffStatusBar:SetValue(0)
	    MasterSS_BuffStatusBar:SetStatusBarColor(0.75,0,0)
		MasterSS_BuffStatusBar.text:Hide()
		
	elseif SPEC_ID == 3 then --Bear
		MasterSS.powerFrame.RageBar:Show()
		MasterSS_BuffStatusBar:SetMinMaxValues(0,18)
		MasterSS_BuffStatusBar:SetValue(0)
	    MasterSS_BuffStatusBar:SetStatusBarColor(0.73,0.73,0)
		MasterSS_BuffStatusBar.text:Show()
	elseif SPEC_ID == 4 then --Tree
		MasterSS.powerFrame.ManaBar:Show()
		MasterSS_BuffStatusBar:SetMinMaxValues(0,20)
		MasterSS_BuffStatusBar:SetValue(0)
	    MasterSS_BuffStatusBar:SetStatusBarColor(0.93,0.93,0)
		MasterSS_BuffStatusBar.text:Hide()
	end	
end

function MSS_OnChangeForm()	
	ResetComboBar()
	if MSS_SavedOptions["switch_on_shapeshift"] == 1 then
		MasterSS.powerFrame.RageBar:Hide()
		MasterSS.powerFrame.EnergyBar:Hide()
		MasterSS.powerFrame.ManaBar:Hide()
		MasterSS.powerFrame.EclipseBar:Hide()
		local formId = GetShapeshiftFormID()
		local specId = GetSpecialization()
		if formId == 5 then
			MasterSS.powerFrame.RageBar:Show()
		elseif formId == 1 then
			MasterSS.powerFrame.EnergyBar:Show()
		elseif formId == 31 then --moonkin
			MasterSS.powerFrame.EclipseBar:Show()
		else
			if specId == 1 then
				MasterSS.powerFrame.EclipseBar:Show()
			else 
				MasterSS.powerFrame.ManaBar:Show()
			end
		end
	end
end


function MSS_OnEvent(self, event, ...)
	if event == "PLAYER_SPECIALIZATION_CHANGED" or event == "PLAYER_ENTERING_WORLD" then
		MSS_OnChangeSpecialization()
		MSS_OnChangeForm()	
	elseif event == "PLAYER_REGEN_DISABLED" then -- Enter combat		
		if MSS_SavedOptions["enable_mss"] == 1 and MSS_SavedOptions["hide_no_combat"] == 1 then
			self:Show()
			MasterSSMask:Show()
		end
	elseif event == "PLAYER_REGEN_ENABLED" then -- Leave combat
		if MSS_SavedOptions["enable_mss"] == 1 and MSS_SavedOptions["hide_no_combat"] == 1 then
			self:Hide()
			MasterSSMask:Hide()
		end
	elseif event == "UPDATE_SHAPESHIFT_FORM" then
		MSS_OnChangeForm()
	end
end


function MSS_OnUpdate(self, elapsed)
	self.updateTimer = self.updateTimer + elapsed
	if self.updateTimer > 0.5 then
		self.updateTimer = 0
		UpdatePortrait()
	end
end


function MSS_Float_OnUpdate(self, elapsed, spellId)
	local n = GetSpellInfo(spellId)
	local name, rank, icon, count, dispelType, duration, expires = UnitBuff("player", n)
		
	if MSS_SavedOptions["lock_float_icon"] == 0 then
		self.image:Show()
	elseif name ~= nil then
		if self.isPlaying == 0 then
			self.image.pulse:Play()			
			self.isPlaying = 1
		end		
		self.image:Show()
		self.text:SetText(format("%d", expires - GetTime()))
		self.text:Show()
		if count > 0 then
			self.textCount:SetText(count)
			self.textCount:Show()		
		end
	else 
		self.image:Hide()
		self.text:Hide()
		self.textCount:Hide()
	end	
end


-- Player HP bar
function MyHpBar_OnUpdate(self, elapsed)
	local maxhp = UnitHealthMax("player")
	local hp = UnitHealth("player")
	self:SetMinMaxValues(0, maxhp)
	
	local baseAP, pos, neg = UnitAttackPower("player")
	local AP = baseAP + pos - neg
	local Agi = UnitStat("player", 2)
	local stamina = UnitStat("player", 3)	
	local modifier = max(2 * (AP - (Agi*2)), stamina * 2.5) 
	
	if UnitPower("player", SPELL_POWER_RAGE) < 60 then
		modifier = modifier * UnitPower("player", SPELL_POWER_RAGE) / 60
	end
	-- print(modifier)
	self:SetValue(hp + (modifier))	
	
	MSS_RealHpBar:SetMinMaxValues(0, maxhp)
	MSS_RealHpBar:SetValue(hp)	
	if hp / maxhp >= 0.25 then
		MSS_RealHpBar:SetStatusBarColor(0,1,0)
	else
		MSS_RealHpBar:SetStatusBarColor(0.8,0,0)
	end
end


-- Target HP bar
function TargetHpBar_OnUpdate(self, elapsed)
	local maxhp = UnitHealthMax("target")
	local hp = UnitHealth("target")
	if maxhp == 0 then
		self:SetAlpha(0)
	else		
		self:SetAlpha(1)
		self:SetMinMaxValues(0, maxhp)
		self:SetValue(hp)
		if hp / maxhp >= 0.8 then
			self:SetStatusBarColor(0, 1, 0)
		elseif hp / maxhp >= 0.25 then
			self:SetStatusBarColor(1,1,0)
		else
			self:SetStatusBarColor(0.8,0,0)
		end
	end
end



--[[
------------------------------------------------------------------------------


-- Create the parent frame that will contain the inner scroll child,
-- all font strings, and the scroll bar slider.
local fp = FPreviewFrame or CreateFrame("ScrollFrame", "FPreviewFrame")
 
-- This is a bare-bones frame is used to encapsulate the contents of
-- the scroll frame.  Each scrollframe can have one scroll child.
local fpsc = FPreviewSC or CreateFrame("Frame", "FPreviewSC")
 
-- Create the slider that will be used to scroll through the results
local fpsb = FPreviewScrollBar or CreateFrame("Slider", "FPreviewScrollBar", fp)
 
-- Set up internal textures for the scrollbar, background and thumb texture
if not fpsb.bg then
   fpsb.bg = fpsb:CreateTexture(nil, "BACKGROUND")
   fpsb.bg:SetAllPoints(true)
   fpsb.bg:SetTexture(0, 0, 0, 0.5)
end
 
if not fpsb.thumb then
   fpsb.thumb = fpsb:CreateTexture(nil, "OVERLAY")
   fpsb.thumb:SetTexture("Interface\\Buttons\\UI-ScrollBar-Knob")
   fpsb.thumb:SetSize(25, 25)
   fpsb:SetThumbTexture(fpsb.thumb)
end
 
local genv = getfenv(0)
 
-- Collect the names of all possible globally defined fonts
local fonts = {}
for k, v in pairs(genv) do
   if type(v) == "table" and type(v.GetObjectType) == "function" then
      local otype = v:GetObjectType()
      if otype == "Font" then
         table.insert(fonts, k)
      end
   end
end
 
-- Sort the list alphabetically
table.sort(fonts)
 
-- Create a table that will contain the font strings themselves
fpsc.fstrings = fpsc.fstrings or {}
 
-- This changes the padding between font strings vertically
local PADDING = 5
 
-- Store the max width and overall height of the scroll child
local height = 0
local width = 0
 
-- Iterate the list of fonts collected
for idx, fname in ipairs(fonts) do
   -- If the font string is not created, do so
   if not fpsc.fstrings[idx] then
      print(idx, fname)
      fpsc.fstrings[idx] = fpsc:CreateFontString("FPreviewFS" .. idx, "OVERLAY")
   end
    
   -- Set the font string to the correct font object, set the text to be the
   -- name of the font and set the height/width of the font string based on
   -- the size of the resulting 'string'.
   local fs = fpsc.fstrings[idx]
   fs:SetFontObject(genv[fname])
   fs:SetText(fname)
   local fwidth = fs:GetStringWidth()
   local fheight = fs:GetStringHeight()
   fs:SetSize(fwidth, fheight)
    
   -- Place the font strings in rows starting at the top-left
   if idx == 1 then
      fs:SetPoint("TOPLEFT", 0, 0)
      height = height + fheight
   else
      fs:SetPoint("TOPLEFT", fpsc.fstrings[idx - 1], "BOTTOMLEFT", 0, - PADDING)
      height = height + fheight + PADDING
   end
    
   -- Update the 'max' width of the frame
   width = (fwidth > width) and fwidth or width
end
 
-- Set the size of the scroll child
fpsc:SetSize(width, height)
 
-- Size and place the parent frame, and set the scrollchild to be the
-- frame of font strings we've created
fp:SetSize(width, 400)
fp:SetPoint("CENTER", UIParent, 0, 0)
fp:SetScrollChild(fpsc)
fp:Show()
 
fpsc:SetSize(width, height)
 
-- Set up the scrollbar to work properly
local scrollMax = height - 400
fpsb:SetOrientation("VERTICAL");
fpsb:SetSize(16, 400)
fpsb:SetPoint("TOPLEFT", fp, "TOPRIGHT", 0, 0)
fpsb:SetMinMaxValues(0, scrollMax)
fpsb:SetValue(0)
fpsb:SetScript("OnValueChanged", function(self)
      fp:SetVerticalScroll(self:GetValue())
end)
 
-- Enable mousewheel scrolling
fp:EnableMouseWheel(true)
fp:SetScript("OnMouseWheel", function(self, delta)
      local current = fpsb:GetValue()
       
      if IsShiftKeyDown() and (delta > 0) then
         fpsb:SetValue(0)
      elseif IsShiftKeyDown() and (delta < 0) then
         fpsb:SetValue(scrollMax)
      elseif (delta < 0) and (current < scrollMax) then
         fpsb:SetValue(current + 20)
      elseif (delta > 0) and (current > 1) then
         fpsb:SetValue(current - 20)
      end
end)

]]
